<template>
  <div>
    <template v-if="!loading && !currentDesignManagementPlan">
      <div class="card card-custom text-center">
        <i class="flaticon2-open-box text-secondary icon-3x"></i>

        <h4>
          Data Tidak Ditemukan.
        </h4>
      </div>
    </template>

    <template v-if="currentDesignManagementPlan">
      <div class="card card-custom p-5 gutter-b">
        <div class="card-body p-0">
          <div class="row">
            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Kode Proyek</label>

              <b-form-input
                id="input-large"
                size="lg"
                disabled
                placeholder="Masukkan Kode Proyek"
                v-model="form.code"
              ></b-form-input>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Owner Proyek</label>

              <b-form-input
                id="input-large"
                size="lg"
                disabled
                placeholder="Masukkan Owner"
                v-model="form.owner"
              ></b-form-input>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Nama Proyek</label>

              <b-form-input
                id="input-large"
                size="lg"
                disabled
                placeholder="Masukkan Nama Proyek"
                v-model="form.name"
              ></b-form-input>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Nomor Kontrak</label>

              <b-form-input
                id="input-large"
                size="lg"
                disabled
                placeholder="Masukkan Nomor Kontrak"
                v-model="form.contractNo"
              ></b-form-input>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Status</label>

              <b-form-select
                v-model="form.status"
                :options="options.statuses"
                size="lg"
                disabled
              ></b-form-select>
            </div>
          </div>

          <div class="d-flex justify-content-end mt-3">
            <b-button variant="success" class="mr-2" @click="save">
              <i class="flaticon2-check-mark"></i> Simpan
            </b-button>

            <b-button variant="secondary" class="mr-2" @click="draft">
              <i class="flaticon2-contract"></i> Draft
            </b-button>

            <b-button variant="secondary">
              <i class="flaticon2-printer"></i> Print
            </b-button>
          </div>
        </div>
      </div>

      <div class="card card-custom p-5 gutter-b">
        <div class="card-body p-0">
          <b-tabs content-class="mt-3">
            <b-tab title="Info DMP">
              <dmp-info
                :dmp-info="currentForm.design_management_plan"
                @setDmpInfo="setCurrentForm"
              ></dmp-info>
            </b-tab>

            <b-tab title="Uraian Lingkup Pekerjaan Kontrak">
              <description
                :descriptions="currentForm.scope_of_contract"
                @setDescriptions="setCurrentForm"
              ></description>
            </b-tab>

            <b-tab title="Daftar Singkatan">
              <abbrevation
                :abbreviations="currentForm.acronym"
                @setAbbreviations="setCurrentForm"
              ></abbrevation>
            </b-tab>

            <b-tab title="Acuan Design">
              <design-reference
                :design-references="currentForm.design_reference"
                @setDesignReferences="setCurrentForm"
              ></design-reference>
            </b-tab>

            <b-tab title="Lingkup Pekerjaan Design">
              <design-scope
                :design-scopes="currentForm.scope_of_design"
                @setDesignScopes="setCurrentForm"
              ></design-scope>
            </b-tab>
          </b-tabs>
        </div>
      </div>
    </template>
  </div>
</template>

<script>
import Description from "./edit-components/Description.vue";
import Abbrevation from "./edit-components/Abbrevation.vue";
import DesignReference from "./edit-components/DesignReference.vue";
import DmpInfo from "./edit-components/DmpInfo.vue";
import DesignScope from "./edit-components/DesignScope.vue";
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import {
  GET_ONE_DESIGN_MANAGEMENT_PLAN_BY_CODE,
  UPDATE_DESIGN_MANAGEMENT_PLAN,
  UPDATE_DRAFT_DESIGN_MANAGEMENT_PLAN
} from "../../../../core/services/store/design-management-plan.module";
import { mapState } from "vuex";

export default {
  name: "EditDmp",
  components: {
    Description,
    DmpInfo,
    Abbrevation,
    DesignReference,
    DesignScope
  },
  data() {
    return {
      form: {
        code: null,
        contractNo: null,
        dmpRevision: null,
        name: null,
        nickname: null,
        owner: null,
        status: null
      },
      currentForm: {
        project: {
          code: null
        },
        design_management_plan: {
          id: null,
          number: null,
          revision: null,
          revision_date: null,
          vp_name: null,
          evp_name: null
        },
        acronym: [],
        scope_of_contract: [],
        scope_of_design: [],
        design_reference: []
      },
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ]
      },
      data: {
        descriptions: [
          {
            id: 1,
            value: "Ini contoh uraian"
          }
        ],
        dmp_info: {
          dmp_number: null,
          revision: null,
          evp_name: null,
          vp_name: null,
          revision_date: null,
          document: null
        },
        abbreviations: [
          {
            id: 1,
            abbreviation: "ER",
            description: "Equipment Room"
          }
        ],
        design_references: [
          {
            id: 1,
            description: "Contoh Uraian",
            type: 1
          }
        ],
        design_scopes: [
          {
            id: 1,
            scope_id: 1,
            subsystem_id: 1,
            description: "ini deskripsi"
          }
        ]
      }
    };
  },
  computed: {
    ...mapState({
      errors: state => state.designManagementPlan.errors,
      loading: state => state.designManagementPlan.loading,
      currentDesignManagementPlan: state =>
        state.designManagementPlan.currentDesignManagementPlan
    }),

    currentData() {
      return this.currentDesignManagementPlan;
    }
  },
  watch: {
    currentData(data) {
      if (data) {
        this.form = {
          code: data?.code,
          contractNo: data?.contract_no,
          dmpRevision: data?.dmp_revision,
          name: data?.name,
          nickname: data?.nickname,
          owner: data?.owner,
          status: data?.status
        };
      }
    }
  },
  methods: {
    save() {
      this.$store
        .dispatch(UPDATE_DESIGN_MANAGEMENT_PLAN, {
          ...this.currentForm,
          project: {
            code: this.form.code
          }
        })
        .then(() => {
          this.toIndexPage();
        });
    },

    draft() {
      this.$store
        .dispatch(UPDATE_DRAFT_DESIGN_MANAGEMENT_PLAN, {
          ...this.currentForm,
          project: {
            code: this.form.code
          }
        })
        .then(() => {
          this.toIndexPage();
        });
    },

    setCurrentForm(data) {
      Object.assign(this.currentForm, data);
    },

    toIndexPage() {
      this.$router.push({
        name: "project-design-management-plan"
      });
    },

    toEditPage(data) {
      this.$router.push({
        name: "edit-detail-project",
        params: {
          code: data.code
        }
      });
    },

    setDescriptions(descriptions) {
      this.data.descriptions = descriptions;
    },

    setPics(pics) {
      this.data.pics = pics;
    },

    setCompanies(companies) {
      this.data.companies = companies;
    },

    setDmpInfo(dmpInfo) {
      this.data.dmp_info = dmpInfo;
    },

    setAbbreviations(abbreviations) {
      this.data.abbreviations = abbreviations;
    },

    setDesignReferences(designReferences) {
      this.data.design_references = designReferences;
    },

    setDesignScopes(designScopes) {
      this.data.design_scopes = designScopes;
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Edit Detail Proyek" }]);

    this.$store.dispatch(GET_ONE_DESIGN_MANAGEMENT_PLAN_BY_CODE, {
      code: this.$route.params?.code
    });
  }
};
</script>

<style></style>
